import jp_design_os
import jp_sim_control
import Stimuli
from jp_stl import *
from VectorGen import *

#####       
# 1. Initialisierung 
###        
openDesign("/hades/examples/simple/dlatch.hds")
jp_design_os.updateDesign()
jp_sim_control.updateSimulator()


#####
# 2. Definition der Ein- und Ausgaenge
###
C = defPinByName("C")
D = defPinByName("D")
Q = defPinByName("Q")


#####
# 3. Definition der Abtastpunkte
###
addProbes(mode="ALL")
n5 = defProbesBevor(Q)

#####
# 4. Definition des Zeitrasters der Stimuli
###



 
#####
# 5. Definiton der Clocks, die an die IPins angelegt werden
###

#####
# 6. Definition des Eingabeformates
###

    
#####
# 7. Definiton der Stimuli
###
def lastStimuli(count):
    v = VectorGen()
    v.defTiming(0.0, 0.001, (0.001*count))
    v.defFormat([C, D])
    #v.addToDesign()
    
    stimuli = []
    state = 0
    for i in range(count):
        state = not state
        if(state):
            stimuli.append(1)
            stimuli.append(1)
        else:
            stimuli.append(0)
            stimuli.append(0)
    v.executeStimuli(stimuli)
    


def lastTest(count):
    v = VectorGen()
    v.defTiming(0.0, 0.001, (0.001*count))
    v.defFormat([C, D, n5])
    #v.addToDesign()
    stimuli = []
    state = 0
    for i in range(count):
        state = not state
        if(state):
            stimuli.append(1)
            stimuli.append(1)
            stimuli.append(1)
        else:
            stimuli.append(0)
            stimuli.append(0)
            stimuli.append(1)
    result = v.executeTest(stimuli)
    print result


def randomTest(count):
    from java.util import Random
    random = Random()
    v = VectorGen()    
    v.defFormat([C, D])
    v.defTiming(0.0, 0.001, (0.001*count))
    v.addToDesign()
    stimuli = []
    state = 0
    for i in range(count):
        for y in range(2):
            if(random.nextDouble()<0.5):
                stimuli.append(1)
            else:
                stimuli.append(0)
    v.executeStimuli(stimuli) 

     
#####
# main
###



for nand in jp_design_os.get("Nand2"):
    nand.setDelay(0.001)

lastTest(100)
#lastStimuli(1000)
#randomTest(1000)





