import jp_design_os
import jp_sim_control
import Stimuli
from jp_stl import *
from VectorGen import *

#####       
# 1. Initialisierung 
###        
openDesign("/hades/examples/simple/dlatch.hds")
jp_design_os.updateDesign()
jp_sim_control.updateSimulator()
v = VectorGen()


#####
# 2. Definition der Ein- und Ausgaenge
###
C = defPinByName("C")
D = defPinByName("D")
Q = defPinByName("Q")


#####
# 3. Definition der Abtastpunkte
###
addProbes(mode="ALL")
n5, n4, n3, n2, n1, n0 = defAllProbes()

#n5 = defProbesBevor(Q)
#n1 = defProbesAfter(C)
#n0 = defProbesAfter(D)


#####
# 4. Definiton der Stimuli
###
v.defTiming(start=0.0, end=0.2)

v.defFormat([
    C, D, n5
    ])

def test_stimuli():
    v.defStimuli([
        1, 1, ["AND", n1, n0],
        1, 0, ["OR", n1, n0],
        U, U, ["AND", n1, n0],
        1, 1, ["NOT", n1],
        0, 1, ["NOT", n1],
        1, 1, ["AND", n0, n1, n2, n3, n4, n5],
        1, 1, ["OR", n0, n1, n2, n3, n4, n5]
        ])


def last_test_random(count, v):
    from java.util import Random
    random = Random()
    test = [1,1,1]
    for i in range(count-1):
        for j in range(2):
            if(random.nextDouble()<0.5):
                test.append(1)
            else:
                test.append(0)
        test.append(1)
    v.defStimuli(test, debug=1)

def last_test(count, v):
    state = 0
    test = []
    for i in range(count):
        state = not state
        if(state):
            test.append(1)
            test.append(1)
            test.append(1)
        else:
            test.append(0)
            test.append(0)
            test.append(1)

    v.defStimuli(test, debug=1)


def setNandDelay(delay):
    design = jp_design_os.getDesign()
    nands = jp_design_os.get("Nand2")
    for nand in nands:
        nand.setDelay(delay)

######
# 5. Starten durch hinzufgen zum design
###
#setNandDelay(0.0001)
#v.defTiming(start=0.0, end=0.002)
v.setDebug(1)

last_test_random(50, v)

v.start()


